#include <iostream>
using namespace std;

#define MAX 50

int empilhar(int v[], int &topo, int valor);
int desempilhar(int v[], int &topo, int &valor);

int main(void) {
    // Declara a pilha
    int bin[MAX];
    int topo = -1;

    // Varivel para armazenar dado digitado
    int dado;
    // Varivel que indica se acabaram valores da pilha
    int vazia;
    // Valor de calculo
    int resto, quociente;

    cout << "Digite um numero inteiro: ";
    cin >> dado;

    do {
        quociente = dado / 2;
        resto = dado % 2;
        empilhar(bin, topo, resto);
        dado = quociente;
    } while(dado > 0);

    // Agora mostra o reultado...
    do {
        vazia = desempilhar(bin, topo, dado);
        if (vazia == 0) cout << dado;
    } while (vazia == 0);

    cout << "b" << endl;
}

// Empilha um valor
// Entrada:
//  v: vetor com elementos da pilha
//  topo: topo da pilha
//  valor: valor a ser empilhado
// Retorna:
//  1- Se pilha cheia
//  0- Caso contrrio
int empilhar(int v[], int &topo, int valor) {
    // Se a pilha est cheia... retorna 1
    if (topo>=MAX-1) {
        //cout << "ERRO: Pilha cheia!" << endl;
        return 1;
    }
    // Se pilha no est cheia, vamos empilhar
    topo = topo + 1;
    v[topo] = valor;
    // Indica que valor foi empilhado
    return 0;
}


// Desempilha um valor
// Entrada:
//  v: vetor com elementos da pilha
//  topo: topo da pilha
//  valor: Local a colocar valor desempilhado
// Retorna:
//  valor: valor desempilhado
//  1- Se pilha vazia
//  0- Caso contrrio
int desempilhar(int v[], int &topo, int &valor) {
    // Se a pilha est vazia... retorna 1
    if (topo<0) {
        //cout << "ERRO: Pilha vazia!" << endl;
        return 1;
    }
    // Se pilha no est vazia, vamos desempilhar
    valor = v[topo];
    topo = topo - 1;
    // Indica que valor foi desempilhado
    return 0;
}


