#include <iostream>
using namespace std;

// Define a Estrutura N
struct No {
    int valor;      // Valor armazenado
    No * prox;      // Ponteiro para prximo elemento da lista
};

// Percorre a lista, imprimindo cada elemento
void imprimir(No * lista);
// Insere valor no incio da lista
No * inserirInicio(No * lista, int valor);
// Remove elemento do incio da lista
No * removerInicio(No * lista, int &valor);

// Procura elemento com um valor especfico na lista
No * buscar(No * lista, int valor);
// Substitui o valor do elemento na posio POS por VALOR
void substituir(No * lista, int pos, int valor);


int main(void) {
    // Declara lista vazia
    No * lista = NULL;
    int n, i, val; // Variveis gerais

    // Solicita quantidade de valores a ler
    cout << "Quantos valores voce deseja ler?" << endl;
    cin >> n;

    // Repete a leitura/insero quantas vezes necessrio
    for (i=0; i<n; i++) {
        cout << "Digite o valor: ";
        cin >> val;
        lista = inserirInicio(lista, val);
    }

}

// Imprime todos os valores de uma lista
void imprimir(No * lista) {
    No * atual; // Ponteiro para "n atual"
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Imprime valor do n atual
        cout << atual->valor << endl;
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
}

// Insere um valor no incio da lista
No * inserirInicio(No * lista, int valor) {
    No * tmp; // Ponteiro para armazenar endereo de n temporariamente
    // Cria n
    tmp = new No;
    // Configura n...
    tmp->valor = valor; // Valor do n
    tmp->prox = lista; // Prximo n  o antigo incio da lista
    // Aponta incio da lista para o novo n
    lista = tmp;
    // Retorna o novo incio da lista
    return lista;
}

// Remove um n do incio da lista, retornando seu valor
No * removerInicio(No * lista, int &valor) {
    No * tmp; // Ponteiro temporrio
    // Se a lista est vazia, vai embora
    if (lista == NULL) return NULL;
    // Armazena valor do elemento sendo removido
    valor = lista->valor;
    // Armazena endereo de elemento a ser removido
    tmp = lista;
    // Aponta inicio da lista para segundo elemento
    lista = lista->prox;
    // Remove o primeiro elemento da lista
    delete tmp;
    // Retorna novo incio da lista
    return lista;
}

// Procura o n com um valor especfico e retorna o ponteiro para esse n
No * buscar(No * lista, int valor) {
    No * atual; // Ponteiro para "n atual"
    // Inicia com o primeiro n como "n atual"
    atual = lista;
    // Enquanto o n atual no for inexistente, repete:
    while(atual != NULL) {
        // Se o valor do n atual for o valor procurado...
        if ( atual->valor == valor ) {
            // Retorna o ponteiro para o n atual
            return atual;
        }
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
    }
    // Caso a lista tenha chegado ao fim sem encontrar, retorna NULL
    return NULL;
}

// Substitui o valor de um n na posio POS da lista
void substituir(No * lista, int pos, int valor) {
    No * atual; // Ponteiro para "n atual"
    int i; // Contador de posies
    // Se a posio procurada  anterior  primeira, vai embora
    if (pos < 1) return;
    // Inicia com o primeiro n como "n atual"...
    atual = lista;
    // ... e este n  o primeiro (nmero 1)
    i = 1;
    // Enquanto o n atual no for inexistente, repete:
    while (atual != NULL) {
        // Se o nmero do n atual (i) for igual  posio proccurada (POS)
        if (i == pos) {
            // Recupera o valor do n...
            atual->valor = valor;
            // Finaliza a repetio do while
            break;
        }
        // Pega o prximo n e o coloca como "n atual"
        atual = atual->prox;
        // Atualiza contador de ns
        i++;
    }
}
